using Microsoft.EntityFrameworkCore;
using FishFactoryContracts.BindingModels;
using FishFactoryContracts.SearchModels;
using FishFactoryContracts.StoragesContracts;
using FishFactoryContracts.ViewModels;
using FishFactoryDatabaseImplement.Models;

namespace FishFactoryDatabaseImplement.Implements
{
    public class OrderStorage : IOrderStorage
    {
        public OrderViewModel? Delete(OrderBindingModel model)
        {
            using var context = new FishFactoryDatabase();
            var element = context.Orders
                .Include(x => x.Canned)
                .Include(x => x.Client)
                .Include(x => x.Implementer)
                .FirstOrDefault(rec => rec.Id == model.Id);
            if (element != null)
            {
                context.Orders.Remove(element);
                context.SaveChanges();
                return element.GetViewModel;
            }
            return null;
        }

        public OrderViewModel? GetElement(OrderSearchModel model)
        {
            using var context = new FishFactoryDatabase();
            if (model.Id.HasValue)
            {
                return context.Orders
                    .Include(x => x.Canned)
                    .Include(x => x.Client)
                    .Include(x => x.Implementer)
                    .FirstOrDefault(x => x.Id == model.Id)
                    ?.GetViewModel;
            }
            else if (model.ImplementerId.HasValue && model.OrderStatus.HasValue)
            {
                return context.Orders
                    .Include(x => x.Canned)
                    .Include(x => x.Client).Include(x => x.Implementer)
                    .FirstOrDefault(x => x.ImplementerId == model.ImplementerId && x.Status == model.OrderStatus)
                    ?.GetViewModel;
            }
            else if (model.ImplementerId.HasValue)
            {
                return context.Orders
                    .Include(x => x.Canned)
                    .Include(x => x.Client).Include(x => x.Implementer)
                    .FirstOrDefault(x => x.ImplementerId == model.ImplementerId)
                    ?.GetViewModel;
            }
            return null;
        }

        public List<OrderViewModel> GetFilteredList(OrderSearchModel model)
        {
            if (model == null) return new();
            using var context = new FishFactoryDatabase();
            if (model.DateFrom.HasValue && model.DateTo.HasValue)
            {
                return context.Orders
                        .Include(x => x.Canned)
                        .Include(x => x.Client).Include(x => x.Implementer)
                        .Where(x => x.DateCreate >= model.DateFrom && x.DateCreate <= model.DateTo)
                        .Select(x => x.GetViewModel)
                        .ToList();
            }
            else if (model.ClientId.HasValue)
                return context.Orders
                    .Include(x => x.Canned)
                    .Include(x => x.Client).Include(x => x.Implementer)
                    .Where(x => x.ClientId == model.ClientId)
                    .Select(x => x.GetViewModel)
                    .ToList();
            else if (model.OrderStatus.HasValue)
                return context.Orders
                        .Include(x => x.Canned)
                        .Include(x => x.Client).Include(x => x.Implementer)
                        .Where(x => x.Status == model.OrderStatus)
                        .Select(x => x.GetViewModel)
                        .ToList();
            else if (model.Id.HasValue)
                return context.Orders
                    .Include(x => x.Canned)
                    .Include(x => x.Client).Include(x => x.Implementer)
                    .Where(x => x.Id == model.Id)
                    .Select(x => x.GetViewModel)
                    .ToList();
            return new();
        }
        public List<OrderViewModel> GetFullList()
        {
            using var context = new FishFactoryDatabase();
            return context.Orders
                .Include(x => x.Canned)
                .Include(x => x.Client)
                .Include(x => x.Implementer)
                .Select(x => x.GetViewModel)
                .ToList();
        }

        public OrderViewModel? Insert(OrderBindingModel model)
        {
            var newOrder = Order.Create(model);
            if (newOrder == null)
            {
                return null;
            }
            using var context = new FishFactoryDatabase();
            context.Orders.Add(newOrder);
            context.SaveChanges();
            return context.Orders
                          .Include(x => x.Canned)
                          .Include(x => x.Client)
                          .Include(x => x.Implementer)
                          .FirstOrDefault(x => x.Id == newOrder.Id)
                          ?.GetViewModel;
        }

        public OrderViewModel? Update(OrderBindingModel model)
        {
            using var context = new FishFactoryDatabase();
            var order = context.Orders
                .Include(x => x.Canned)
                .Include(x => x.Client)
                .Include(x => x.Implementer)
                .FirstOrDefault(x => x.Id == model.Id);
            if (order == null)
            {
                return null;
            }
            order.Update(model);
            context.SaveChanges();
            return order.GetViewModel;
        }
    }
}
